# Tutorials

> 原文： [http://docs.cython.org/en/latest/src/tutorial/index.html](http://docs.cython.org/en/latest/src/tutorial/index.html)

*   [基础教程](cython_tutorial.html)
    *   [Cython 的基础知识](cython_tutorial.html#the-basics-of-cython)
    *   [Cython Hello World](cython_tutorial.html#cython-hello-world)
    *   [斐波那契乐趣](cython_tutorial.html#fibonacci-fun)
    *   [Primes](cython_tutorial.html#primes)
    *   [使用 C ++进行推广](cython_tutorial.html#primes-with-c)
    *   [语言详细信息](cython_tutorial.html#language-details)
*   [调用 C 函数](external.html)
    *   [动态链接](external.html#dynamic-linking)
    *   [外部声明](external.html#external-declarations)
    *   [命名参数](external.html#naming-parameters)
*   [使用 C 库](clibraries.html)
    *   [定义外部声明](clibraries.html#defining-external-declarations)
    *   [编写包装类](clibraries.html#writing-a-wrapper-class)
    *   [内存管理](clibraries.html#memory-management)
    *   [编译和链接](clibraries.html#compiling-and-linking)
*   [扩展类型（又名.cdef 类）](cdef_classes.html)
*   [pxd 文件](pxd_files.html)
*   [警告](caveats.html)
*   [分析](profiling_tutorial.html)
    *   [Cython Profiling Basics](profiling_tutorial.html#cython-profiling-basics)
    *   [分析教程](profiling_tutorial.html#profiling-tutorial)
*   [Unicode 和传递字符串](strings.html)
    *   [Cython 代码中的 Python 字符串类型](strings.html#python-string-types-in-cython-code)
    *   [字符串文字](strings.html#string-literals)
    *   [关于 C 字符串的一般说明](strings.html#general-notes-about-c-strings)
    *   [传递字节串](strings.html#passing-byte-strings)
    *   [接受 Python 代码中的字符串](strings.html#accepting-strings-from-python-code)
    *   [处理“const”](strings.html#dealing-with-const)
    *   [将字节解码为文本](strings.html#decoding-bytes-to-text)
    *   [将文本编码为字节](strings.html#encoding-text-to-bytes)
    *   [C ++字符串](strings.html#c-strings)
    *   [自动编码和解码](strings.html#auto-encoding-and-decoding)
    *   [源代码编码](strings.html#source-code-encoding)
    *   [单字节和字符](strings.html#single-bytes-and-characters)
    *   [窄版本构建](strings.html#narrow-unicode-builds)
    *   [迭代](strings.html#iteration)
    *   [Windows 和宽字符 API](strings.html#windows-and-wide-character-apis)
*   [内存分配](memory_allocation.html)
*   [纯 Python 模式](pure.html)
    *   [增加.pxd](pure.html#augmenting-pxd)
    *   [魔法属性](pure.html#magic-attributes)
    *   [提示与技巧](pure.html#tips-and-tricks)
*   [使用 NumPy](numpy.html)
    *   [添加类型](numpy.html#adding-types)
    *   [高效索引](numpy.html#efficient-indexing)
    *   [进一步调整索引](numpy.html#tuning-indexing-further)
    *   [更通用的代码](numpy.html#more-generic-code)
*   [使用 Python 数组](array.html)
    *   [内存视图的安全使用](array.html#safe-usage-with-memory-views)
    *   [零开销，不安全访问原始 C 指针](array.html#zero-overhead-unsafe-access-to-raw-c-pointer)
    *   [克隆，扩展阵列](array.html#cloning-extending-arrays)
    *   [API 参考](array.html#api-reference)
*   [进一步阅读](readings.html)
*   [相关工作](related_work.html)
*   [附录：在 Windows 上安装 MinGW](appendix.html)